#define KEY_DIR	"/var/lib/nf2fa"

struct key
{
	time_t		itime;
	time_t		ts;
	char		name[32];
	char		key[32];
	unsigned char	id;
	char		ip[40];
	char		pass[15];

	struct key	*next;
};


char		*key_error(void);

int		key_pass_validate(const char *pass, const char *pass2);
int		key_pass_set(struct key *k, const char *pass);
int		key_pass_verify(struct key *k, const char *pass);

int		key_save(const unsigned int uid, const struct key *k);
int		key_load(struct key *k, const unsigned int uid,
			const unsigned char key_id);

int		key_remove(const unsigned int uid, const unsigned char id);

