#define _GNU_SOURCE

#include <stdio.h>
#include <string.h>

#include "totp.h"

int main(void)
{
	int r;
	char out[64], *e;
	char *key = "234A";
	unsigned int tc = 300;

	e = "615309";
	r = totp_compute(out, key, tc, 6 /*digits*/);
	if (r != 0) {
		fprintf(stderr, "totp_compute returned %d [%s]!\n",
			r, totp_error());
		return 1;
	}
	if (strcmp(out, e) != 0) {
		fprintf(stderr, "totp_compute returned %s intead of %s!\n",
			out, e);
		return 1;
	}

	e = "0545615309";
	r = totp_compute(out, key, tc, 10 /*digits*/);
	if (r != 0) {
		fprintf(stderr, "totp_compute returned %d [%s]!\n",
			r, totp_error());
		return 1;
	}
	if (strcmp(out, e) != 0) {
		fprintf(stderr, "totp_compute returned %s intead of %s!\n",
			out, e);
		return 1;
	}

	fprintf(stderr, "All OK!\n");
	return 0;
}
